# BBBS Daemons

## Situació

El programari `BBBS`, es composa de dos mòduls principals, un que fa les funcions de concentrador de connexions i un altre que és el programari de `BBS` com a tal.

Tots dos s'inicien de manera manual.


## Problema

Davant de situacions que requereixen reiniciar totalment l'equip on s'executa `BBBS`, o putinejar els `runlevel`, aquestes execucions es finalitzen, requerint iniciar-les de nou de manera manual.

En situacions on hi ha establert algun mecanisme de tipus `wake-on-lan` o similar, i que es produeix en circumstàncies que no precisen de presència i/o intervenció humana, arrencar manualment els serveis `BBBS` pot ser un inconvenient.


## Solució

Recolzar-se en el dimoni de sistema `systemd`[^1] per definir dos serveis que activen i ofereixen la connectivitat necessària al programari `BBBS`, tant entrant com sortint, i que s'inicien i aturen, de la mà del sistema.

* `bbbsd2.service` és el servei encarregat de donar la connectivitat entre *Nodes* de *FidoNet*, establint les comunicacions sortints (*outbound*) cap aquells *links* als que *EOTB* contacta (*uplinks*), i captant les comunicacions entrants (*inbound*) d'aquells *links* que contacten amb *EOTB* (*downlinks* i *punts*).

* `bbbsd3.service` és el servei encarregat de donar la connectivitat entre *Usuaris* de *EOTB*, establint les comunicacions entrants del dimoni `BBBS` pels protocols `telnet`, `ftp`, `http`, `binkp` i les seves variants xifrades amb `SSL`.

### Llicència de `BBBS`:

S'ha de tenir en compte que els serveis d'aquest repositori estan ajustats al llicènciament que tinc establert amb en `Kim Heino, el creador del programari, de manera que heu d'ajustar[^2] el número de nodes d'inici i de final de servei, d'acord a la vostra situació.


## Execució

De cara a fer servir els dos serveis, seguirem les passes habituals.

Per exemple, per a `bbbsd3.service`, copiar el servei allà on `systemd` el buscarà:

```bash
cp bbbsd3.service /etc/systemd/system/.
```
Recarregar `systemd` per tal que el dimoni reconegui l'existència del nou servei: 

```bash
root@fidobox:/opt/bash# systemctl daemon-reload
```
Fer que `systemd` activi el nou servei:

```bash
systemctl enable bbbsd3.service

Created symlink /etc/systemd/system/multi-user.target.wants/bbbsd3.service → /etc/systemd/system/bbbsd3.service.
```

I verificar que `systemd` és capaç d'iniciar i aturar el servei sense problemes:

```bash
root@fidobox:/opt/bash# systemctl start bbbsd3.service
```

```bash
root@fidobox:/opt/bash# systemctl stop bbbsd3.service
```


`<EOF>`

[^1]: Per si algú no està funcionant amb `systemd`, incloc, dins la carpeta `initd` els anteriors serveis que feia servir per al dimoni `init`: `bbbsd2` crida a `bbbsd2.sh`, i `bbbsd3` crida a `bbbsd3.sh`, també per establir la connectivitat sortint i entrant, respectivament.
[^2]: A la línia `ExecStart=/opt/bbbs/bbbs 2 2 ...` de `bbbsd2.service`, o a la línia `ExecStart=/opt/bbbs/bbbsd 3 995 ...` de `bbbsd3.service`, cal ajustar els números d'acord amb la vostra llicència i/o el repartiment de funcions que volgueu fer. Seguint el manual del producte no hi ha misteri, però contacteu-me i us dono un cop de mà.